module Carquery
  Trim = BaseStruct.new :id, :title, :make_code, :trim, :year, :body, :engine_position,
                        :engine_cc, :engine_cyl, :engine_type, :engine_valves_per_cyl,
                        :engine_power_ps, :engine_power_rpm, :engine_torque_nm, :engine_torque_rpm,
                        :engine_bore_mm, :engine_stroke_mm, :engine_compression, :engine_l,
                        :engine_ci, :engine_bore_in, :engine_stroke_in, :engine_valves,
                        :engine_power_hp, :engine_power_kw, :engine_torque_lbft,
                        :engine_torque_kgm, :top_speed_mph, :weight_lbs, :length_in,
                        :width_in, :height_in, :wheelbase_in,  :engine_fuel,
                        :top_speed_kph, :speedup_0_to_100_kph, :drive, :transmission_type,
                        :seats, :doors, :weight_kg, :length_mm, :width_mm, :height_mm,
                        :wheelbase_mm, :lkm_hwy, :lkm_mixed, :lkm_city, :fuel_cap_l,
                        :mpg_city, :mpg_hwy, :mpg_mixed, :fuel_cap_g, :sold_in_us,
                        :co2, :make_title, :make_country do

    def self.build raw
      new get_i( raw["model_id"] ),
          get_str( raw["model_name"] ),
          get_str( raw["model_make_id"] ),
          get_str( raw["model_trim"] ),
          get_i( raw["model_year"] ),
          get_str( raw["model_body"] ),
          get_str( raw["model_engine_position"] ),
          get_i( raw["model_engine_cc"] ),
          get_i( raw["model_engine_cyl"] ),
          get_str( raw["model_engine_type"] ),
          get_i( raw["model_engine_valves_per_cyl"] ),
          get_i( raw["model_engine_power_ps"] ),
          get_i( raw["model_engine_power_rpm"] ),
          get_i( raw["model_engine_torque_nm"] ),
          get_i( raw["model_engine_torque_rpm"] ),
          get_f( raw["model_engine_bore_mm"] ),
          get_f( raw["model_engine_stroke_mm"] ),
          get_f( raw["model_engine_compression"] ),
          get_f( raw["model_engine_l"] ),
          get_i( raw["model_engine_ci"] ),
          get_f( raw["model_engine_bore_in"] ),
          get_f( raw["model_engine_stroke_in"] ),
          get_i( raw["model_engine_valves"] ),
          get_i( raw["model_engine_power_hp"] ),
          get_i( raw["model_engine_power_kw"] ),
          get_i( raw["model_engine_torque_lbft"] ),
          get_i( raw["model_engine_torque_kgm"] ),
          get_f( raw["model_top_speed_mph"] ),
          get_i( raw["model_weight_lbs"] ),
          get_f( raw["model_length_in"] ),
          get_f( raw["model_width_in"] ),
          get_f( raw["model_height_in"] ),
          get_f( raw["model_wheelbase_in"] ),
          get_str( raw["model_engine_fuel"] ),
          get_i( raw["model_top_speed_kph"] ),
          get_f( raw["model_0_to_100_kph"] ),
          get_str( raw["model_drive"] ),
          get_str( raw["model_transmission_type"] ),
          get_i( raw["model_seats"] ),
          get_i( raw["model_doors"] ),
          get_i( raw["model_weight_kg"] ),
          get_i( raw["model_length_mm"] ),
          get_i( raw["model_width_mm"] ),
          get_i( raw["model_height_mm"] ),
          get_i( raw["model_wheelbase_mm"] ),
          get_f( raw["model_lkm_hwy"] ),
          get_f( raw["model_lkm_mixed"] ),
          get_f( raw["model_lkm_city"] ),
          get_i( raw["model_fuel_cap_l"] ),
          get_f( raw["model_mpg_city"] ),
          get_f( raw["model_mpg_hwy"] ),
          get_f( raw["model_mpg_mixed"] ),
          get_f( raw["model_fuel_cap_g"] ),
          get_boolean( raw["model_sold_in_us"] ),
          get_i( raw["model_co2"] ),
          get_str( raw["make_display"] ),
          get_str( raw["make_country"] )
    end

  end
end
